﻿module openssl;

import std.c.stdio : FILE;

public:
extern(C):

typedef void SSL_METHOD;
typedef void SSL_CTX;
typedef void SSL;

SSL_METHOD* SSLv23_client_method();
SSL_CTX* SSL_CTX_new(SSL_METHOD*);
SSL* SSL_new(SSL_CTX*);
int SSL_set_fd(SSL*, int fd);
int RAND_poll();
int RAND_status();
void RAND_seed(void* buf, int num);
void SSL_load_error_strings();
int SSL_library_init();
void ERR_print_errors_fp(FILE* fp);
int SSL_connect(SSL*);
int SSL_write(SSL*, const(void)* buf, int len);
int SSL_read(SSL*, void* buf, int len);
int SSL_shutdown(SSL*);
void SSL_free(SSL*); 
void SSL_CTX_free(SSL_CTX*);
void ERR_free_strings();

alias extern(C) int function(char* str, size_t len, void* p) CB_FUNC;
void ERR_print_errors_cb(CB_FUNC, void* p);

