﻿


import sslsocketstream;
import std.string : format;
import std.stdio : writefln;
import std.c.stdio : printf; // writeflnはUTF8以外表示できない
import std.socket;

void main(string[] args) {
	if (args.length != 3) {
		writefln("USAGE: %s hostname path", args[0]);
		return;
	}

	auto host = args[1];
	auto path = args[2];
	auto port = 443; // SSLのポート

	scope addr = new InternetAddress(host, port);
	scope sock = new TcpSocket(addr);
	scope ss = new SSLSocketStream(sock);

	//writefln(host);
	//writefln(path);
	auto request = format("GET %s HTTP/1.0\r\nHost: %s\r\n\r\n", path, host);
	//writefln("request");
	//writefln("[%s]", request);
	ss.writeString(request);
	
	ubyte[] responce;
	while (1) {
		auto buf = new ubyte[128];
		auto len = ss.read(buf);
		responce ~= buf[0..len];
		if (ssl.eof())
			break;
	}

	//writefln("responce");
	printf("%.*s", responce);

	//writefln("end");
}

